;APS00000000000000000000000000000000000000000000000000000000000000000000000000000000
;////////////////////////////////////////////////////////////////////////////
;// Main Code and Bmp saver coded by E-Moon/Endzeit 99.
;// Esp made for the #amycoders texturecompo.

; *************** Exec ******************

_LVOOpenLibrary  EQU -552
_LVOCloseLibrary EQU -414

; ************** Dos ********************

_LVOOpen  EQU -30
_LVOClose EQU -36
_LVOWrite EQU -48

MODE_NEWFILE    EQU    1006

;//////////////////////////////////////
;// Some Macros

BI_RGB		EQU	0
BI_RLE8		EQU	1
BI_RLE4		EQU	2

D_BSWAP	    MACRO
	    rol.w   #8,\1
	    swap    \1
	    rol.w   #8,\1
	    ENDM

W_BSWAP	    MACRO
	    rol.w   #8,\1
	    ENDM	

WORD	    MACRO		; word (16 bits)
\1	    EQU     SOFFSET
SOFFSET     SET     SOFFSET+2
	    ENDM

DWORD	    MACRO		; word (16 bits)
\1	    EQU     SOFFSET
SOFFSET     SET     SOFFSET+4
	    ENDM

STRUCTURE   MACRO		; structure name, initial offset
\1	    EQU     0
SOFFSET     SET     \2
	    ENDM

LABEL	    MACRO		; Define a label without bumping the offset
\1	    EQU     SOFFSET
	    ENDM

	STRUCTURE tagBITMAPFILEHEADER,0
		WORD	bfType;			// Always "BM"
		DWORD   bfSize;			// Size of File
		WORD    bfReserved1;		// Reserved = 0
		WORD    bfReserved2;		// Reserved = 0
		DWORD   bfOffBits;		// Offset to bitmap data
	LABEL tagBITMAPFILEHEADER_SIZEOF	

	STRUCTURE tagBITMAPINFOHEADER,0
		DWORD  biSize;			// size needed by struct
		DWORD  biWidth;			// Xsize of Picture
		DWORD  biHeight;		// Ysize of Picture
		WORD   biPlanes;		// planes for taget (must be 1)
		WORD   biBitCount;		// bits per pixel
		DWORD  biCompression;		// Type of Compression
		DWORD  biSizeImage;		// Size in bytes of the Image
		DWORD  biXPelsPerMeter;		// Xpixels per meter.
		DWORD  biYPelsPerMeter;		// Ypixels per meter
		DWORD  biClrUsed;		// Colors used (color index)
		DWORD  biClrImportant;		// For Indexed mode.
	LABEL tagBITMAPINFOHEADER_SIZEOF	



;////////////////////////////////////////////////////////////////////
;// Routine to write the texture buffer down to a Bmp file.
;// :TODO: Code a general routine that isnt fixed to 256*256
;// 	   Optimize and clean up the code.	

SaveBmpFile
;		lea	TextureBuffer,a0
		lea	BmpData,a1
		move.l	#256,d0			; x size
		move.l	#256,d1			; y size
		move.l	#24,d2			; 24bit
		move.l	d0,d3			; x
		muls.l	d1,d3			; x*y
		add.l	#56,d3			; Fixme!
		D_BSWAP	d3			; Intel format
		
		;////////////////////////////////
		;// Write to header.

		move.w	#"BM",bfType(a1)	; BmpData
		move.l	d3,bfSize(a1)
		move.w	#0,bfReserved1(a1)
		move.w	#0,bfReserved2(a1)
		move.l	#54,d3			; Fixme
		D_BSWAP	d3			; Intel format
		move.l	d3,bfOffBits(a1)
		add.l	#tagBITMAPFILEHEADER_SIZEOF,a1

		;////////////////////////////////
		;// Info Structure.	

		move.l	#tagBITMAPINFOHEADER_SIZEOF,d3
		D_BSWAP	d3			; Intel Format
		move.l	d3,biSize(a1)		; Size
		move.l	d0,d3			; x
		move.l	d1,d4			; x
		D_BSWAP	d3			; Intel Format
		D_BSWAP	d4			; Intel Format
		move.l	d3,biWidth(a1)		; Store
		move.l	d4,biHeight(a1)		; Store
		move.w	#1<<8,biPlanes(a1)	; Planes = 1 (Intel Format)
		W_BSWAP	d2
		move.w	d2,biBitCount(a1)	; 24bit
		move.l	#BI_RGB,biCompression(a1)	; no Compress
		move.l	#0,biSizeImage(a1)	; ?	
		move.l	#0,biXPelsPerMeter(a1)	; ? 		
		move.l	#0,biYPelsPerMeter(a1)	; ? 		
		move.l	#0,biClrUsed(a1)	; ? 		
		move.l	#0,biClrImportant(a1)	; ? 		
		
		add.l	#tagBITMAPINFOHEADER_SIZEOF,a1

		;////////////////////////////////////////////////////
		;// Put the texture inside the 
		;// The Bmp Struct.

		move.l	d1,d5
		add.l	#256*255*4,a0
.loopy
		move.l	a0,a2
		move.l	d0,d4
		subq.l	#1,d4	;LOOP FIX!
.loopx
		addq.l	#1,a2
		move.b	(a2)+,d3	; x
		move.b	(a2)+,d1	; x
		move.b	(a2)+,d2	; x

		move.b	d2,(a1)+		
		move.b	d1,(a1)+		
		move.b	d3,(a1)+		

		subq.l	#1,d4
		bge.s	.loopx

		sub.l	#(256*1*4),a0

		subq.l	#1,d5
		bge.s	.loopy

		;////////////////////////////////////////////////////////////
		;// Write the file down to disk

		moveq	#0,d0
		move.l	$4.w,a6
		lea	.DosName,a1
		jsr	_LVOOpenLibrary(a6)	; Get Dos lib
		move.l	d0,a6
		moveq	#0,d0
		move.l	#TextureName,d1		; Name
		move.l	#MODE_NEWFILE,d2	; NewFile
		jsr	_LVOOpen(a6)
		move.l	d0,.pFile		; File Handle

		move.l	d0,d1
		move.l	#BmpData,d2
		move.l	#(256*256*3)+56,d3
		jsr	_LVOWrite(a6)		; Write to disk
		move.l	.pFile,d1
		jsr	_LVOClose(a6)

		rts

.pFile		dc.l	0
.DosName	dc.b	"dos.library",0,0

		section	bss,bss

BmpData		ds.b	256+(256*256*4)
